#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2two29004xi.py">
#<abstract4xi abstract = "fires to direction two and to distance 2900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2two29004xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2TWO - COORDINATE SIGNS OF SHOOT2TWO4XI: (X + ,Y - ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2two29004xi

#"
#/>

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

# -------------------------------------------------------------------------------------------------
# 2900
# -------------------------------------------------------------------------------------------------
shot2two29004xi = {
        1:'102x-2896y-90z',
        2:'1034x-1262y-2396z',
        3:'1083x-1189y-2412z',
        4:'110x-1904y-2184z',
        5:'1126x-1113y-2428z',
        6:'1128x-2655y-292z',
        7:'115x-1229y-2624z',
        8:'1165x-1037y-2444z',
        9:'116x-1539y-2454z',
        10:'1198x-959y-2460z',
        11:'11x-1929y-2164z',
        12:'1227x-880y-2475z',
        13:'1228x-57y-2626z',
        14:'1250x-124y-2613z',
        15:'1250x-802y-2490z',
        16:'1264x-2589y-321z',
        17:'1267x-193y-2601z',
        18:'1269x-723y-2505z',
        19:'1281x-264y-2588z',
        20:'1283x-644y-2519z',
        21:'1290x-337y-2574z',
        22:'1291x-566y-2533z',
        23:'1295x-412y-2561z',
        24:'1296x-488y-2547z',
        25:'1396x-2517y-350z',
        26:'1493x-2485y-27z',
        27:'1524x-2437y-378z',
        28:'1621x-2403y-56z',
        29:'1648x-2351y-407z',
        30:'1744x-2315y-85z',
        31:'1766x-2258y-436z',
        32:'176x-1195y-2636z',
        33:'1862x-2219y-114z',
        34:'1879x-2159y-465z',
        35:'194x-1506y-2470z',
        36:'1975x-2118y-143z',
        37:'1986x-2054y-493z',
        38:'207x-1874y-2203z',
        39:'2082x-2010y-172z',
        40:'2087x-1944y-522z',
        41:'2182x-1829y-550z',
        42:'2183x-1897y-201z',
        43:'2270x-1708y-579z',
        44:'2278x-1779y-229z',
        45:'233x-1158y-2648z',
        46:'2351x-1584y-607z',
        47:'2366x-1656y-258z',
        48:'2426x-1455y-635z',
        49:'2447x-1529y-287z',
        50:'2493x-1323y-664z',
        51:'2521x-1397y-316z',
        52:'254x-2886y-119z',
        53:'2552x-1188y-692z',
        54:'2587x-1262y-345z',
        55:'2605x-1050y-720z',
        56:'2647x-1123y-374z',
        57:'2649x-910y-748z',
        58:'2686x-768y-776z',
        59:'268x-1470y-2485z',
        60:'2698x-982y-402z',
        61:'2715x-625y-804z',
        62:'2736x-480y-832z',
        63:'2742x-838y-431z',
        64:'2749x-336y-859z',
        65:'2751x-46y-915z',
        66:'2754x-191y-887z',
        67:'2778x-692y-460z',
        68:'2801x-750y-8z',
        69:'2805x-545y-488z',
        70:'2825x-397y-517z',
        71:'2836x-602y-37z',
        72:'2837x-248y-545z',
        73:'2840x-99y-574z',
        74:'2863x-453y-66z',
        75:'286x-1119y-2659z',
        76:'2882x-302y-95z',
        77:'2893x-151y-124z',
        78:'302x-1839y-2221z',
        79:'339x-1429y-2500z',
        80:'348x-1114y-2763z',
        81:'36x-1567y-2439z',
        82:'393x-1798y-2240z',
        83:'404x-2867y-147z',
        84:'406x-1386y-2514z',
        85:'470x-1339y-2528z',
        86:'480x-1754y-2258z',
        87:'529x-1289y-2543z',
        88:'52x-1259y-2611z',
        89:'553x-2841y-176z',
        90:'564x-1705y-2276z',
        91:'585x-1236y-2556z',
        92:'637x-1181y-2570z',
        93:'645x-1651y-2294z',
        94:'685x-1124y-2583z',
        95:'701x-2806y-205z',
        96:'721x-1594y-2312z',
        97:'728x-1066y-2596z',
        98:'767x-1005y-2609z',
        99:'792x-1534y-2329z',
        100:'801x-944y-2622z',
        101:'805x-23y-2785z',
        102:'830x-67y-2777z',
        103:'832x-881y-2634z',
        104:'846x-2763y-234z',
        105:'853x-114y-2769z',
        106:'858x-818y-2646z',
        107:'860x-1470y-2346z',
        108:'873x-164y-2760z',
        109:'879x-755y-2658z',
        110:'890x-216y-2751z',
        111:'897x-692y-2669z',
        112:'904x-270y-2742z',
        113:'910x-629y-2680z',
        114:'914x-326y-2732z',
        115:'918x-566y-2691z',
        116:'921x-384y-2722z',
        117:'923x-1403y-2363z',
        118:'923x-504y-2702z',
        119:'924x-444y-2712z',
        120:'981x-1334y-2380z',
        121:'989x-2713y-263z'}
        
#"
#"/>

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2900two4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2900two4xi(queue2two, consumer_channel2two, publisher_channel2two):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2900TWO4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2900TWO4XI -  QUEUE2TWO: ", queue2two)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2900TWO4XI -  CONSUMER_CHANNEL2TWO: ", consumer_channel2two)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2900TWO4XI -  PUBLISHER_CHANNEL2TWO: ", publisher_channel2two)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2900TWO4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2two.put(shot2two29004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2900TWO4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2900TWO4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2900TWO4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2two8shot2two29004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2two8shot2two29004xi</nack2put4xi>" 
            
        publisher_channel2two.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2900TWO4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2900TWO4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2900TWO4XI - RETURNING QUEUE OBJECT QUEUE2TWO: ", queue2two, " - TIME: ", time4xi())  
        # 
            
    return queue2two    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verbkb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>
        

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2two29004xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
        